#include <iostream>

#include "champsscalaires.h"


ChampsScalaires::ChampsScalaires(int n, int m)
{
 tab = new float[(n+2) * (m+2)];
 taillex = n+2;
 tailley = m+2;
 int i;

 for(i=0; i<taillex * tailley;i++)
   tab[i] = 0.0f;

}

ChampsScalaires::~ChampsScalaires()
{
 delete tab;
 taillex = 0;
 tailley = 0;
}

float ChampsScalaires::max() const
{
  float max = lire(0,0);
  int i;

  for(i=0;i<taillex * tailley; i++)
   {
    if(max< tab[i])
      max = tab[i];
   }

 return max;

}

float ChampsScalaires::min() const
{
  float min = lire(0,0);
  int i;

  for(i=0;i<taillex * tailley; i++)
   {
    if(min> tab[i])
      min = tab[i];
   }

 return min;

}



void ChampsScalaires::annuler()
{
 int i;
 for(i=0;i<taillex * tailley;i++)
  tab[i] = 0.0f;
}

int ChampsScalaires::tailleX() const
{
 return taillex;
}
int ChampsScalaires::tailleY() const
{
 return tailley;
}

float ChampsScalaires::pas() const
{
return 1.0f / ((float) taillex-2.0f);
}

void ChampsScalaires::somme(int i, int j, float element)
{
  ecrire(i,j, lire(i,j) + element);
}

ChampsScalaires* ChampsScalaires::clone() const
{
 ChampsScalaires* c = new ChampsScalaires(taillex-2, tailley-2);
 copie(c);
 return c;
}

void ChampsScalaires::copie(ChampsScalaires* c)  const
{
 int i;
 for(i=0; i<taillex * tailley;i++)
   c->tab[i] = tab[i];

}

void ChampsScalaires::sommeScalaires(ChampsScalaires* c, float coeff)
{

 //ne touche pas au bord, trs important :)
 for(int j=1; j<tailley-1; j++)
  for(int i=1; i<taillex-1; i++)
  {
    somme(i,j, c->lire(i,j) * coeff);
  }

}
