#include "champsscalaires.h"
#include "champsvecteurs.h"



ChampsVecteurs::ChampsVecteurs(int n, int m)
{
 x = new ChampsScalaires(n, m);
 y = new ChampsScalaires(n, m);
}

ChampsVecteurs::~ChampsVecteurs()
{
 delete x;
 delete y;
}

ChampsScalaires *ChampsVecteurs::getX()  const
{
 return x;
}

ChampsScalaires *ChampsVecteurs::getY()  const
{
 return y;
}

void ChampsVecteurs::ecrire(int i, int j, float ex, float ey)
{
 x->ecrire(i, j, ex);
 y->ecrire(i, j, ey);
}

int ChampsVecteurs::tailleX()  const
{
 return getX()->tailleX();
}

int ChampsVecteurs::tailleY()  const
{
 return getX()->tailleY();
}

void ChampsVecteurs::annuler()
{
 x->annuler();
 y->annuler();

}

float ChampsVecteurs::pas() const
{
 return x->pas();
}

ChampsVecteurs* ChampsVecteurs::clone() const
{
  ChampsVecteurs* v = new ChampsVecteurs(tailleX()-2, tailleY()-2);

  x->copie(v->x);
  y->copie(v->y);

  return v;
}

void ChampsVecteurs::copie(ChampsVecteurs* c) const
{
 x->copie(c->x);
 y->copie(c->y);
}
