#ifndef _OBSTACLE_H
#define _OBSTACLE_H

/*
 Title: Obstacle
 */

/*
 class: Obstacle
  Permet la gestion d'obstacle
*/
class Obstacle
{
  private:
   int x;
   int y;
   int w;
   int h;
 public:
   /*
    Constructor: Obstacle
    Paramtres:
     xi - dbut de position horizontale de l'obstacle
     yi - debut de position verticsale de l'obstacle
     wi - taille horizontale
     hi - taille verticale
   */
   Obstacle(int xi, int yi, int wi, int hi);
   Obstacle() {};

   /*
     Method: getX
     Retour: Renvoit le dbut de position horizontale
   */
   int getX()  const;

   /*
     Method: getY
     Retour: Renvoit le dbut de position verticale
   */
   int getY() const;

   /*
    Method: getW
    Retour: Renvoit la taille horizontale de l'obstacle
  */
   int getW() const;

  /*
   Method: getH
   Retour: Renvoit la taille verticale de l'obstacle
  */
  int getH() const;

   Obstacle& operator = (Obstacle &source)
   {
     x  = source.x;
     y = source.y;
     w = source.w;
     h = source.h;
     return *this;
   }

};


#endif
